function _ts_decorate(decorators, target, key, desc) {
    var c = arguments.length, r = c < 3 ? target : desc === null ? desc = Object.getOwnPropertyDescriptor(target, key) : desc, d;
    if (typeof Reflect === "object" && typeof Reflect.decorate === "function") r = Reflect.decorate(decorators, target, key, desc);
    else for(var i = decorators.length - 1; i >= 0; i--)if (d = decorators[i]) r = (c < 3 ? d(r) : c > 3 ? d(target, key, r) : d(target, key)) || r;
    return c > 3 && r && Object.defineProperty(target, key, r), r;
}
function _ts_metadata(k, v) {
    if (typeof Reflect === "object" && typeof Reflect.metadata === "function") return Reflect.metadata(k, v);
}
import { PrimaryColumn, Entity, Index, JoinColumn, Column, ManyToOne } from "typeorm";
import { User } from "./user.js";
import { Note } from "./note.js";
import { UserGroup } from "./user-group.js";
import { id } from "../id.js";
export let NoteReaction = class NoteReaction {
    id;
    createdAt;
    userId;
    user;
    groupId;
    group;
    noteId;
    note;
    // TODO: 対象noteのuserIdを非正規化したい(「受け取ったリアクション一覧」のようなものを(JOIN無しで)実装したいため)
    reaction;
};
_ts_decorate([
    PrimaryColumn(id()),
    _ts_metadata("design:type", String)
], NoteReaction.prototype, "id", void 0);
_ts_decorate([
    Index(),
    Column("timestamp with time zone", {
        comment: "The created date of the NoteReaction."
    }),
    _ts_metadata("design:type", typeof Date === "undefined" ? Object : Date)
], NoteReaction.prototype, "createdAt", void 0);
_ts_decorate([
    Index(),
    Column(id()),
    _ts_metadata("design:type", Object)
], NoteReaction.prototype, "userId", void 0);
_ts_decorate([
    ManyToOne((type)=>User, {
        onDelete: "CASCADE"
    }),
    JoinColumn(),
    _ts_metadata("design:type", Object)
], NoteReaction.prototype, "user", void 0);
_ts_decorate([
    Index(),
    Column({
        ...id(),
        nullable: true
    }),
    _ts_metadata("design:type", Object)
], NoteReaction.prototype, "groupId", void 0);
_ts_decorate([
    ManyToOne((type)=>UserGroup, {
        onDelete: "CASCADE"
    }),
    JoinColumn(),
    _ts_metadata("design:type", Object)
], NoteReaction.prototype, "group", void 0);
_ts_decorate([
    Index(),
    Column(id()),
    _ts_metadata("design:type", Object)
], NoteReaction.prototype, "noteId", void 0);
_ts_decorate([
    ManyToOne((type)=>Note, {
        onDelete: "CASCADE"
    }),
    JoinColumn(),
    _ts_metadata("design:type", Object)
], NoteReaction.prototype, "note", void 0);
_ts_decorate([
    Column("varchar", {
        length: 260
    }),
    _ts_metadata("design:type", String)
], NoteReaction.prototype, "reaction", void 0);
NoteReaction = _ts_decorate([
    Entity(),
    Index([
        "userId",
        "noteId"
    ], {
        unique: true,
        where: '"groupId" IS NULL'
    }),
    Index([
        "groupId",
        "noteId"
    ], {
        unique: true,
        where: '"groupId" IS NOT NULL'
    })
], NoteReaction);
